#include <unistd.h>
#include <malloc.h>
#include <mraa/spi.h>
#include <mraa/gpio.h>

static mraa_spi_context spi_context = NULL;

// static void bmi160_cs_on()
// {
// 	if (gpioContext)
// 		mraa_gpio_write(gpioContext, 0);
// }
// 
// static void bmi160_cs_off()
// {
// 	if (gpioContext)
// 		mraa_gpio_write(gpioContext, 1);
// }

void LoopTransceive(int length)
{
	uint8_t *pattern;
	uint8_t *result;

	if (!spi_context)
		printf("spi_context is NULL.\n");

	pattern = malloc(length);
	result = malloc(length);

	for(int i = 0; i < length; i++)
		pattern[i] = (uint8_t)i + 1;

	// bmi160_cs_on();

	if(mraa_spi_transfer_buf(spi_context, pattern, result, length))
	{
		// bmi160_cs_off();
		printf("mraa_spi_transfer_buf() failed.\n");
	}

	printf("Pattern: 0x");
	for(int i = 0; i < length; i++)
	{
		if(result[i] < 15)
			printf("0");
		printf("%X", pattern[i]);
	}
	printf("\n");

	printf("Result: 0x");
	for(int i = 0; i < length; i++)
	{
		if(result[i] < 15)
			printf("0");
		printf("%X", result[i]);
	}
	printf("\n");

	// bmi160_cs_off();

	free(pattern);
	free(result);
}


void Init()
{

	int mraa_rv;
	if ((mraa_rv = mraa_init()) != MRAA_SUCCESS)
		printf("mraa_init() failed (%d).\n", mraa_rv);

	if (!(spi_context = mraa_spi_init(0)))
		printf("mraa_spi_init() failed.\n");

	// // only create cs context if we are actually using a valid pin.
	// // a hardware controlled pin should specify cs as -1.
	// if (cs_pin >= 0)
	// {
	// 	if (!(gpiocontext = mraa_gpio_init(cs_pin)))
	// 	{
	// 		printf("%s: mraa_gpio_init() failed.\n", __function__);
	// 		bmi160_close(dev);
	// 		return null;
	// 	}

	// 	mraa_gpio_dir(gpiocontext, mraa_gpio_out);
	// 	bmi160_cs_off();
	// }

	if(mraa_spi_mode(spi_context, 0))
		printf("mraa_spi_mode() failed.\n");

	if (mraa_spi_frequency(spi_context, 16000000))
		printf("mraa_spi_frequency() failed.\n");
}


void main()
{
	printf("Running Spi Test 5\n");
	Init();
	LoopTransceive(8);
	printf("Test Done\n");
}
